/***********************************************************************
 *
 * PROJECT: PalmXQ
 * FILE:    defs.h
 * AUTHOR:  Cheok Yan Cheng
 *
 * DESCRIPTION: All constants and macros for PalmXQ.
 *
 * LAST REVISION:   24/02/2002
 *
 ***********************************************************************/

#ifndef _DEFS_H
#define _DEFS_H

#define LOAD_EVENT           firstUserEvent
#define MOVE_EVENT           ( firstUserEvent + 1 )

/* minimun OS version to use app */
#define MINOSVERSION 0x03003000

/* agressive of null move forward pruning */
#define R   2

#define frmRedrawnBoardCode 1000

#define STATUS_STR_LEN  32

#define BRD_WIDTH   9
#define BRD_HEIGHT  10
#define BRD_SIZE    (BRD_WIDTH * BRD_HEIGHT)
#define BRD_BOUND_PIXEL 1
#define PIECEBMP_PIXEL  13

#define DARK			0
#define LIGHT			1
#define SIDE_MASK       1
#define EMPTY   7

#define PAWN    0
#define ASSISTANCE  1
#define ELEPHANT    2
#define KNIGHT  3
#define CANNON  4
#define ROOK    5
#define KING    6

/* We assume numbers of legal move in each ply is 35. The cchess engine can
   have up to 32 level of search tree (MAX_PLY). Thus, we need a stroge which
   is up to size 35 * 32 (GEN_STACK).

   We also assume that the total number of ply in a complete game will not
   exceed 500 moves (HIST_STACK). */
#define GEN_STACK		1120
#define MAX_PLY         32
#define HIST_STACK      500
  
/* For dabase used */
#define GameDBType  'Game'
#define GameDBName  "Games-cHok"

#define CreatorId   'cHok'
#define FileType    'game'

#define saveGameName "Saved Game-cHok"

/* Generic move information */
typedef struct {
    UInt8 from;
    UInt8 to;
    UInt8 padding[ 2 ];
} MoveBytesT;

/* Wrapper to generic move information for easy comparison*/
typedef union {
    MoveBytesT b;
    UInt16   u;
} MoveT;

/* An element of the move stack. it's just a move with a
   score, so it can be sorted by the search functions. */
typedef struct {
    MoveT m;
	Int16 score;
	UInt8 padding[ 2 ];
} GenT;

/* An element of the history stack, with the information
   necessary to take a move back. */
typedef struct {
    MoveT m;
    UInt8 capture;
    UInt8 fifty;
    UInt8 padding[ 2 ];
} HistT;

#endif
